extends Area

# This is called when a rigid body enters the Coin area.
func _on_Coin_body_enter( body ):
	# Right now the player is the only object that can trigger this, 
	# but it doesn't hurt to build this in a way that still works 
	# when there are other moving objects in the game.
	if body.is_in_group("Players"):
		# Let the player react to collecting this coin.
		body.collect(self)
		# Let the animation player handle what the coin is supposed to do.
		get_node("AnimationPlayer").play("collect")
		
		# Disable collision or this coin could be collected again.
		set_collision_mask(0)
		set_layer_mask(0)

# This is called by a Call Func Track in the "collect" animation.
func selfDestruct():
	# Delay destruction of the object until the end of the frame
	# to make sure that all remaining accesses to the object can still find it.
	queue_free()
